#!/bin/bash

TAR_NAME=all_artifacts
DEPLOY_DIR=build/$CI_PIPELINE_ID/${TAR_NAME}
CURRENT_DIR=$PWD

mkdir -p ${CURRENT_DIR}/${DEPLOY_DIR}
cd ${CURRENT_DIR}/${DEPLOY_DIR}

echo "Cleaning up previous archives"
rm -rf ${CURRENT_DIR}/${DEPLOY_DIR}/*

echo "Downloading artifact from $ARTIFACTORY_URL/grafonet/$CI_PIPELINE_ID/${TAR_NAME}.tar.gz"
curl -O -u $ARTIFACTORY_USER:$ARTIFACTORY_PASS "$ARTIFACTORY_URL/grafonet/$CI_PIPELINE_ID/${TAR_NAME}.tar.gz"
ls -larth
pwd
mkdir -p ${TAR_NAME}
tar -xzvf ${TAR_NAME}.tar.gz -C ${CURRENT_DIR}/${DEPLOY_DIR}/${TAR_NAME}
cd ${TAR_NAME}

ls -larth

echo "deploying dashboards"
cd dashboards
for FILE in *;
 do
  echo "$FILE \n";
  DASHBOARD="{\"dashboard\": $(jq . $FILE), \"overwrite\": true}"
  curl -X POST \
   -H "Authorization: Bearer $TOKEN" \
   -H "Content-Type: application/json" \
   -d "$DASHBOARD" \
   $GRAFANA_URL/api/dashboards/db
  echo "\n"
done
cd ..

echo "deploying alerts"
cd alerts
ls -larth

for FILE in *;
 do
  echo "$FILE \n";
  PAYLOAD="$(jq . $FILE)"
  curl -X POST \
   -H "Authorization: Bearer $TOKEN" \
   -H "Content-Type: application/json" \
   -d "$PAYLOAD" \
   $GRAFANA_URL/api/v1/provisioning/alert-rules
  echo "\n"
done

cd ${CURRENT_DIR}

echo "deployment completed"